# FIAB-Board (Foolishly Implemented Again Bulletin-Board)
# By Tatsu 2007,2010,2017
# Version 1.1.0

#ʸȤѴ롣
sub toCharRef {
	my (@argv) = @_;
	my $org = $argv[0];
	my $newStr = "";
	my $i;

	for ($i = 0;$i < length($org);$i++){
		$newStr = $newStr."&#".ord(substr($org,$i,1)).";";
	}
	return $newStr;

}

#񤭹ߤɽ롣
sub showArticle {
	my (@argv) = @_;
	
	printf "<p class='article'>\n";
	if ($argv[0] > 0){
		printf "<span class='description'>Res No:</span><span class='resNo'>%d</span><br>\n",$argv[0];
	}
	printf "<span class='description'>Title:</span><span class='title'>%s</span><br>\n",$argv[1];
	printf "<span class='date'>%s</span><br>\n",$argv[2];
	printf "<span class='description'>By:</span><span class='author'>%s</span><br>\n",$argv[3];
	if (length($argv[4]) > 0){
		printf "<a href=\"mailto:%s\" class='mail'>[Mail]</a>",toCharRef($argv[4]);
	}
	if (length($argv[5]) > 0){
		printf "<a href=\"%s\" class='url'>[Web page]</a>",$argv[5];
	}
	print "<br>\n";
	printf "<br>\n<span class='comment'>%s</span><br>\n",$argv[6];
	printf "<br>\n<span class='user-agent'>%s</span><br>\n",$argv[7];
	print "</p>\n";
	
}

#ʸHTMLѤ˥פ롣
sub escapeHTML {
	my (@argv) = @_;
	my $target = $argv[0];

	$target =~ s/&/&amp;/g;
	$target =~ s/</&lt;/g;
	$target =~ s/>/&gt;/g;
	$target =~ s/\"/&quot;/g;
	$target =~ s/\'/&#39;/g;
#	$target =~ s/ /&nbsp;/g;

	return $target;
}

#ʸURLѤ˥פ롣
sub escapeURL {
	my (@argv) = @_;
	my $target = $argv[0];

	$target =~ s/</&lt;/g;
	$target =~ s/>/&gt;/g;
	$target =~ s/\"/&quot;/g;
	$target =~ s/\'/&#39;/g;
#	$target =~ s/ /&nbsp;/g;

	return $target;
}

#ǿν񤭹դ񤭹
sub writeLatest {
	my @wroteTime = localtime(time);
	my @weekday = ("Sun","Mon","Tue","Wed","Thu","Fri","Sat");

	if (open(FILE,">data/latest.dat")) {
		flock(FILE,2);

		printf FILE "%04d/%02d/%02d (%s) %02d:%02d:%02d\n",
			$wroteTime[5] + 1900,$wroteTime[4]+1,$wroteTime[3],$weekday[$wroteTime[6]],
			$wroteTime[2],$wroteTime[1],$wroteTime[0];

		flock(FILE,8);
		close(FILE);
	}
}

#󥯥å
sub checkLink {
	my (@argv) = @_;

	my $target = ${argv[0]};

	if ($target =~ /h\s*t\s*t\s*p\s*\:/i){
		return 1;
	}

	if ($target =~ /h\s*t\s*t\s*p\s*s\s*\:/i){
		return 1;
	}

	return 0;
}

#3ʸ󥯥å
sub checkLink3 {
	my (@argv) = @_;

	my $target = ${argv[0]};

	if ($target =~ /t\s*t\s*p\s*\:/i){
		return 1;
	}

	if ($target =~ /t\s*t\s*p\s*s\s*\:/i){
		return 1;
	}

	return 0;
}

#renameȤäå
sub my_flock {
	my %lfh = (dir => './lockdir/', basename => 'lockfile',
	     timeout => 60, trytime => 10, @_);

	$lfh{path} = $lfh{dir} . $lfh{basename};

	for (my $i = 0; $i < $lfh{trytime}; $i++, sleep 1) {
		return \%lfh if (rename($lfh{path}, $lfh{current} = $lfh{path} . time));
	}

	# åեΥǥ쥯ȥ롣
	# ǥ쥯ȥ꤬ʤϤǥå԰Ȥ롣
	return undef if !opendir(LOCKDIR, $lfh{dir});
	my @filelist = readdir(LOCKDIR);
	closedir(LOCKDIR);

	foreach (@filelist) {
		if (/^$lfh{basename}(\d+)/) {
			return \%lfh if (time - $1 > $lfh{timeout} and
				rename($lfh{dir} . $_, $lfh{current} = $lfh{path} . time));
			last;
		}
	}
	undef;
}

#renameȤäå
sub my_funlock {
	rename($_[0]->{current}, $_[0]->{path});
}

#̤ΥեåϤ롣
sub putFooter {
print <<"EOM";
<p class="credit">
Powerd by <a href="http://tatsu.life.coocan.jp/">FIAB-Board</a>.<br>
</p>
</body>
</html>
EOM
}

# RSSѤľν񤭹ߤѤ롣
sub putPrevious {
	my (@argv) = @_;
	my $prevCount = 0;
	my $prevTime;
	my $prevLink;
	my $prevAuthor;
	my $prevTitle;
	my $prevArticle;
	
	# äƥݥ˽񤭽Ф
	open(TEMPFILE, ">data/rsstmp.dat") || return;
	
	# ǿν񤭹ߤ񤭹ࡣ
	printf TEMPFILE "%s\n", $argv[0];
	printf TEMPFILE "%s\n", $argv[1];
	printf TEMPFILE "%s\n", $argv[2];
	printf TEMPFILE "%s\n", $argv[3];
	printf TEMPFILE "%s\n", $argv[4];
	
	if (open(PREVFILE, "<data/rssprev.dat")) {
		while(1) {
			# 񤭹ߤɤ߹ࡣ
			$prevTime = readline *PREVFILE;
			if (eof(PREVFILE)){
				last;
			}

			$prevLink = readline *PREVFILE;
			if (eof(PREVFILE)){
				last;
			}

			$prevAuthor = readline *PREVFILE;
			if (eof(PREVFILE)){
				last;
			}

			$prevTitle = readline *PREVFILE;
			if (eof(PREVFILE)){
				last;
			}

			$prevArticle = readline *PREVFILE;

			# 񤭹ߤ񤭽Ф
			printf TEMPFILE "%s", $prevTime;
			printf TEMPFILE "%s", $prevLink;
			printf TEMPFILE "%s", $prevAuthor;
			printf TEMPFILE "%s", $prevTitle;
			printf TEMPFILE "%s", $prevArticle;

			$prevCount++;
			if ($prevCount > 3) {
				last;
			}
		}
		close(PREVFILE);
	}
	close(TEMPFILE);
	
	#ν񤭹ߥե򹹿롣
	unlink("data/rssprev.dat");
	rename("data/rsstmp.dat", "data/rssprev.dat");
}

#RSS񤭤
sub putRSS {
	my (@argv) = @_;
	my @time = ();
	my @link = ();
	my @author = ();
	my @title = ();
	my @article = ();
	my $error = 0;
	my $count = 0;

	if (open(PREVFILE, "<data/rssprev.dat")) {
		while (1) {
			$time[$count] = readline *PREVFILE;
			if (eof(PREVFILE)){
				$error = 1;
				last;
			}
			chomp($time[$count]);
			
			$link[$count] = readline *PREVFILE;
			if (eof(PREVFILE)){
				$error = 1;
				last;
			}
			chomp($link[$count]);

			$author[$count] = readline *PREVFILE;
			if (eof(PREVFILE)){
				$error = 1;
				last;
			}
			chomp($author[$count]);

			$title[$count] = readline *PREVFILE;
			if (eof(PREVFILE)){
				$error = 1;
				last;
			}
			chomp($title[$count]);

			$article[$count] = readline *PREVFILE;
			chomp($article[$count]);

			$count++;

			if (eof(PREVFILE)){
				last;
			}
		}
		close(PREVFILE);
	}
	
	if ($error > 0) {
		return;
	}

	if (!open(RSSFILE, ">" . $argv[2] . "bbs.rdf")) {
		return;
	}

	print RSSFILE <<"EOM";
<?xml version="1.0" encoding="EUC-JP" ?>
<rdf:RDF
  xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
  xmlns="http://purl.org/rss/1.0/"
  xmlns:dc="http://purl.org/dc/elements/1.1/"
  xmlns:sy="http://purl.org/rss/1.0/modules/syndication/"
  xmlns:content="http://purl.org/rss/1.0/modules/content/"
>
<channel rdf:about="${argv[0]}bbs.cgi">
<title>${argv[1]}</title>
<link>${argv[0]}bbs.cgi</link>
<dc:language>ja</dc:language>
<dc:date>$time[0]</dc:date>
<items>
<rdf:Seq>
EOM

	my $i;
	for ($i = 0; $i < @link; $i++) {
		printf RSSFILE "<rdf:li rdf:resource=\"%sbbs.cgi?%s\" />\n",$argv[0], $link[$i];
	}

	print RSSFILE <<"EOM";
</rdf:Seq>
</items>
</channel>
EOM

	for ($i = 0; $i < @link; $i++) {
		printf RSSFILE "<item rdf:about=\"%sbbs.cgi?%s\">\n", $argv[0], $link[$i];
		printf RSSFILE "<title>%s</title>\n", $title[$i];
		printf RSSFILE "<link>%sbbs.cgi?%s</link>\n", $argv[0], $link[$i];
		printf RSSFILE "<dc:date>%s</dc:date>\n", $time[$i];
		printf RSSFILE "<dc:creator>%s</dc:creator>\n", $author[$i];
		printf RSSFILE "<content:encoded><![CDATA[\n";
		printf RSSFILE "<p>\n";
		printf RSSFILE "%s\n", $article[$i];
		printf RSSFILE "</p>\n";
		printf RSSFILE "  ]]></content:encoded>\n";
		printf RSSFILE "</item>\n"
	}
	print RSSFILE "</rdf:RDF>\n";
	
	close(RSSFILE);

}

1;
